
#define GENERIC_CHECKS                                      \
	if (!attrs)                                              \
	{                                                        \
		SYNTAX ("%s must have attributes!", eltname);         \
		return;                                               \
	}

#define CASE_STRDUP(STR,MEMB)                        \
   if (!strcmp (attrs[i], STR)) {                    \
      MEMB = g_strdup(attrs[i+1]);                   \
   } else

#define CASE(STR,MEMB)                               \
   if (!strcmp (attrs[i], STR)) {                    \
      MEMB = attrs[i+1];                             \
   } else

#define CASE_UNKNOWN                                         \
   {                                                         \
      SYNTAX ("unknown %s attribute %s", eltname, attrs[i]); \
   }

#define CHECK_NEST(fld,prnt)                                   \
	if (!(fld))                                                 \
	{                                                           \
		SYNTAX ("%s can only occur within a " prnt "!", eltname);\
		return;                                                  \
	}

#define CHECK_NEST2(flda,fldb,prnta,prntb)           \
	if ((!par->flda) && (!par->fldb))                 \
	{                                                 \
		SYNTAX ("%s can only occur within a " prnta    \
              " or " prntb "!", eltname);            \
		return;                                        \
	}

#define REQUIRE(var,what)                            \
	if (NULL == var)                                  \
	{                                                 \
		SYNTAX ("%s must specify " what, eltname);     \
		return;                                        \
	}

#define REQUIRE2(vara,varb,what)                     \
   if ((NULL == vara) && (NULL == varb))             \
   {                                                 \
      SYNTAX ("%s must specify " what, eltname);     \
      return;                                        \
   }

#define REQUIRE3(vara,varb,varc,what)                \
	if ((NULL == vara) && (NULL == varb) && (NULL == varc))   \
	{                                                 \
		SYNTAX ("%s must specify " what, eltname);     \
		return;                                        \
	}

#define REQUIRE4(vara,varb,varc,vard,what)           \
	if ((NULL==vara) && (NULL==varb) && (NULL==varc) && (NULL==vard))   \
	{                                                 \
		SYNTAX ("%s must specify " what, eltname);     \
		return;                                        \
	}

/* =================================================================== */
